import { PureComponent, ReactNode } from 'react';
export declare type View = ReactNode | Function;
export interface ViewProps {
}
export interface SwitchProps {
    selected?: number | number[] | null;
    views?: View[];
    props?: ViewProps | ViewProps[];
    children?: ReactNode;
}
declare class Switch extends PureComponent<SwitchProps> {
    static defaultProps: Partial<SwitchProps>;
    getSelectedIndexes: () => number[];
    getViews: () => View[];
    render(): JSX.Element;
}
export default Switch;
